clear all
close all
clc

Data = 'AnalysisData\';               % Input file path
Des = 'AnalysisResult\';              % Output files folder path
Name = [Data 'List.csv'];
[~,txt,~] = xlsread(Name);            % receive the name of input file


sub_threshold = 0.25; %  set default coeficient of sub_threshold
% sub_threshold = input('Please input the coeficient of sub_threshold (positive number): ');
threshold = input('Please input the threshold (positive number): ');


for i=1:length(txt)
    name = txt{i};
    Destination = [Des name(1:end-4) '\']          % Output file path
    mkdir(Destination)                             % built folders for output file
    [sub_CPA DCA time prices ] = TR1_4_sub_NDC(name,Destination,Data,sub_threshold*threshold);          % for Sub_DC profile
end


for i=1:length(txt)
    name = txt{i};
    Destination = [Des name(1:end-4) '\']          % Output file path
    mkdir(Destination)                             % built folders for output file
%     CPA = TR1_2_3_Profile(name,Destination,Data,threshold);          % for DC profile
    [CPA DCA DCCstar time prices Filepath2] = TR1_4_Profile(name,Destination,Data,threshold);          % for DC profile

end

%%  sub_NDC
sub_NDC = [];

for m=1:length(CPA)-1
    
    temp = 0;
    for n=1:length(sub_CPA)
        if CPA(m)<sub_CPA(n) && CPA(m+1)>sub_CPA(n)  % get subDCC between dcc to dcc 
            temp=1+temp;  % count
        end
    end
    sub_NDC=[sub_NDC temp];
    
   
end
Sub_threshold = threshold * sub_threshold;
MedianSub_NDC = median(sub_NDC);

xlswrite(Filepath2,Sub_threshold,'sheet1','B6');
xlswrite(Filepath2,sub_NDC','sheet1','J11');


%% USV
USV=[0];
for m=2:length(CPA)

h1=CPA(m-1);
h2=DCA(m);
flag=0;
tUS=0;
LDC=0;
HDC=0;

for k = h1:h2  % get time ranges from dcc to ext 
   if prices(k)>prices(k-1) & prices(k)>prices(k-2) %  two rise in a row
       HDC = prices(k);
       
   
       if  prices(k+1)<prices(k) %  begin to down
            flag=1; %LDC marker
       else
           flag=0;
           
       end
   end  
   
   if flag 
       
       LDC = prices(k+1);
       if tUS<HDC-LDC % maximum
           tUS = HDC-LDC;
       end
   end
    
end
USV(m) = tUS/DCCstar(m)/threshold;
end
MedianUSV = median(USV);

xlswrite(Filepath2,USV','sheet1','K11');


WarningSentence = WarningSentence(DCA,Filepath2);

Filepath2 = [Destination name(1:end-4) '_Profile_' num2str(threshold*100) '%.csv']; 

xlswrite(Filepath2,Sub_threshold,'sheet1','B6');
xlswrite(Filepath2,MedianSub_NDC,'sheet1','B24');
xlswrite(Filepath2,MedianUSV,'sheet1','B25');
xlswrite(Filepath2,{WarningSentence},'sheet1','A36');



