function [CPA DCA DCCstar Time prices Filepath1] = TR1_3_Profile(name,Dis,Data,threshold)
format short;
Filename = name(1:end-4);
Filepath1 = [Dis Filename '_DC_Data_' num2str(threshold*100) '%.csv'];   % DC-Data file path
Filepath2 = [Dis Filename '_Profile_' num2str(threshold*100) '%.csv'];   % Profile file path
PicName = [Dis name(1:end-4) '_' num2str(threshold*100) '%.jpg'];        % Graphic file path  
A = load([Data name]);
data = A(:,3);
% [Points Time] = xlsread([Data name]);
[A,B,C,D] = textread([Data name],'%s %s %s %s');
for i=1:length(A)
    temp = [A{i} ',' B{i}];
    Time{i} = temp(1:end-1);
end
clear A B C D
Points = data;
Time = Time(:);
prices = data(:,1);

LLP = 1;
LHP = 1;
LL = prices(LLP);      %memorize the lastLow
LH = prices(LHP);    %memorize the lastHigh
CP = 2;   % Current Point
DCP = 1;  % Directional Change Point
DCA(DCP) = 0; % DCA = Directional Change Array
DCA_Sub = 0;
% Sub_threshold = threshold * sub_threshold;
Conf = 1;
CPA(Conf) = 0;  % memorize confirmation points
CS = 'null';

while CP <= length(prices)
    if prices(CP) <= LH*(1-threshold)         % judge whether directional change has taken place
        DCA(DCP) = LHP;  % append new the directional change point to array
        DCP = DCP+1;
        CPA(Conf) = CP;             % append new the confirmation point to array
        Conf = Conf+1;
        CS = 'DR';                              %record current running situation
        break;
    end
    if prices(CP) >= LL*(1+threshold)           % judge whether directional change has taken place
        DCA(DCP) = LLP;   % append new the directional change point to array
        DCP = DCP+1;
        CPA(Conf) = CP;             % append new the confirmation point to array
        Conf = Conf+1;
        CS = 'UR';                               %record current running situation
        break;
    end
    if prices(CP) > LH                     %judge whether it's need to update lastHigh
        LHP = CP;                      %update lastHigh
        LH = prices(LHP);
    end
    if prices(CP) < LL                      %judge whether it's need to update lastLow
        LLP = CP;                       %update lastLow
        LL = prices(LLP);
    end
    CP = CP+1;
end



while CP <= length(prices)
    if strcmp(CS, 'DR')                   %judge current running situation
        if prices(CP) < LL               %judge whether it's need to update lastLow
            LLP = CP;                %update lastLow
            LL = prices(CP);
        end
        if prices(CP) >= LL*(1+threshold)    % otherwise judge whether directional change has taken place
            CS = 'UR';                          % if it has happened, uptate current running situation
            DCA(DCP) = LLP;    % append new the directional change point to array
            DCP = DCP+1;
            CPA(Conf) = CP;          % append new the confirmation point to array
            Conf = Conf+1;
            LHP = CP;                                %update lastHigh
            LH = prices(CP);
            
            
        end
    end
    if strcmp(CS, 'UR')                         %judge current running situation
        if prices(CP) > LH                  %judge whether it's need to update lastHigh
            LHP = CP;                   %update lastHigh
            LH = prices(CP);
        end
        if prices(CP) <= LH*(1-threshold)   % otherwise judge whether directional change has taken place
            CS = 'DR';                        % if it has happened, uptate current running situation
            DCA(DCP) = LHP;      % append new the directional change point to array
            DCP = DCP+1;
            CPA(Conf) = CP;            % append new the confirmation point to array
            Conf = Conf+1;
            LLP = CP;                                     %update lastLow
            LL = prices(CP);
            
        end
    end
    CP = CP+1;
end

h=figure;
figure(h);
plot(prices, 'color', 'k');      
title([num2str(threshold * 100), '% DCs in ' Filename]);
for index = 1 : DCP - 1              % plot every DC events and overshoot events in loop
    a = [DCA(index), CPA(index)];    % DC event inteval(the inteval between DCP and ConfP)
    b = [prices(DCA(index)), prices(CPA(index))];
    line(a, b,'color', 'r', 'linewidth', 3); 
    if index < length(CPA)
        a = [CPA(index), DCA(index + 1)];     % overshoot event inteval(the inteval between ConfP and DCP)
        b = [prices(CPA(index)), prices(DCA(index+1))];
        line(a, b, 'color', 'g', 'linewidth',3);   
    end
end
figure(h)
j = get(gcf,'javaframe');
set(j,'maximized',true);
legend(Filename, 'Directional Change Events', 'Overshoot Events',2);
print(h,'-djpeg',PicName)
close(h);

TradesOpen = Time(CPA,:);            % T_DCC
TradingPrices = prices([CPA]);       % DC confirmation prices
DCdates = Time(DCA,:);              % T_EXT
DCprices = prices([DCA]);           % DC extreme points

S = size(DCA);                 % number of DC event
S = S(:,2);


DCCstar = [];                                      % caculate DCC star
for i = 1 : S
    if DCprices(i,:) > TradingPrices(i,:)
        DCCstar(i) = DCprices(i,:) * (1 - threshold);
    else
        DCCstar(i) = DCprices(i,:) * (1 + threshold);
    end
end
DCCstar = DCCstar';

% caculate PC,OSV at EXT & TMV at EXT & Coastline
PC = DCprices(end,:) / DCprices(1,:);
OSV = [];
TM = [];
for m = 1 : S-1
    OSV(m) = (DCprices(m+1,:) - DCCstar(m,:)) / DCCstar(m,:) / threshold;
    TM(m) = (DCprices(m+1,:) - DCprices(m,:)) / DCprices(m,:) / threshold;
end
OSV = OSV';
TM = TM';
LenC = sum(abs(TM));
MeanLenC = mean(abs(TM));

% Snapshot calculation
Tfinal = Time(end,:);
Pfinal = Points(end,:);
SPC = Points(end,:) / Points(1,:);
SOSV = (Points(end,:) - TradingPrices(end,:)) / TradingPrices(end,:) / threshold;
STM = (Points(end,:) - DCprices(end,:)) / DCprices(end,:) / threshold;

% calculate DC indicators
TradingPrices = num2cell(TradingPrices);
TradingEvents = cat(2, TradesOpen, TradingPrices);   % find Directional Change Comfirmation Points

DCprices = num2cell(DCprices);
DCevents = cat(2, DCdates, DCprices);       % find Directional Change Extrem Points
Allevents = cat(2, DCevents, TradingEvents);

% calculate time interval
Interval = TR1_4_CountTime(DCA,Time);                         % Physical time difference of EXT
Interval = Interval';

% caculate Up/Down Return in percentage
R_DC = (abs(TM) ./ Interval * threshold)*60*24*360;

% write DC-Data file
% Header
Date= cellstr(datestr(now,'yyyy.mm.dd HH:MM:SS'));
File_input = cellstr(Filename);
headers1 = {'Program_ID:TR1.4'; 'Author: Ran Tao'; 'Date'; 'File_input'; 'Threshold(Theta)';'Sub-Threshold';'Tstart'; 'Tfinal'};
heading1 = {'T_EXT', 'PEXT', 'T_DCC', 'PDCC', 'PDCC*', 'OSVEXT', 'TMVEXT', 'T', 'R_DC', 'sub_NDC', 'USV'};

xlswrite(Filepath1,headers1,'sheet1','A1');
xlswrite(Filepath1,Date,'sheet1','B3');
xlswrite(Filepath1,File_input,'sheet1','B4');
xlswrite(Filepath1,threshold,'sheet1','B5');
% xlswrite(Filepath1,Sub_threshold,'sheet1','B6');
xlswrite(Filepath1,Time(1,:),'sheet1','B7');
xlswrite(Filepath1,Time(end,:),'sheet1','B8');

xlswrite(Filepath1,heading1,'sheet1','A10');

% Body
xlswrite(Filepath1,Allevents,'sheet1','A11');
xlswrite(Filepath1,DCCstar,'sheet1','E11');
xlswrite(Filepath1,OSV,'sheet1','F11');
xlswrite(Filepath1,TM,'sheet1','G11');
% ind = find(Interval==max(Interval));
timethresh = 24*60*60;
ind = find(Interval > timethresh);
Interval(ind,1) = nan; 
xlswrite(Filepath1,Interval,'sheet1','H11');
R_DC(ind,1) = nan;
xlswrite(Filepath1,R_DC,'sheet1','I11'); 



% Profile
% TL
TL = size(Time);
TL = TL(:,1);

% NDC
NDC = S;

% Median OSV, T, VT, R_DC, 
MedianOSV_overall = median(abs(OSV));
MedianT_overall = median(Interval);
MedianR_DC_overall = median(R_DC);


for i = 1 : S-1
    if OSV(i,:) > 0
        OSV_up(i) = OSV(i,:);
        T_up(i) = Interval(i,:); 
        R_DC_up(i) = R_DC(i,:);
        
        OSV_up(OSV_up == 0) = [];
        T_up(T_up == 0) = [];
        R_DC_up(R_DC_up == 0) = [];
        
        MedianOSV_up = median(abs(OSV_up));
        MedianT_up = median(T_up);
        MedianR_DC_up = median(R_DC_up);
    else
        OSV_down(i) = OSV(i,:);
        T_down(i) = Interval(i,:); 
        R_DC_down(i) = R_DC(i,:);
        
        OSV_down(OSV_down == 0) = [];
        T_down(T_down == 0) = [];
        R_DC_down(R_DC_down == 0) = [];
        
        MedianOSV_down = median(abs(OSV_down));
        MedianT_down = median(T_down);
        MedianR_DC_down = median(R_DC_down);
        
    end
end


% write Profile file
% Header
headers2 = {'Program_ID:TR1.4'; 'Author: Ran Tao'; 'Date'; 'File_input'; 'Threshold(Theta)';'Sub-Threshold';'Tstart';'Tfinal'};
heading2 = {'TL'; 'NDC';'PC';'MedianOSV_overall';'MedianOSV_up';'MedianOSV_down';'MedianT_overall';'MedianT_up';'MedianT_down';'MedianR_DC_overall';'MedianR_DC_up';'MedianR_DC_down';'LenC';'MeanLenC';'MedianSub_NDC';'MedianUSV'};

xlswrite(Filepath2,headers2,'sheet1','A1');
xlswrite(Filepath2,Date,'sheet1','B3');
xlswrite(Filepath2,File_input,'sheet1','B4');
xlswrite(Filepath2,threshold,'sheet1','B5');
% xlswrite(Filepath2,Sub_threshold,'sheet1','B6');
xlswrite(Filepath2,Time(1,:),'sheet1','B7');
xlswrite(Filepath2,Time(end,:),'sheet1','B8');

xlswrite(Filepath2,heading2,'sheet1','A10');

% Body
xlswrite(Filepath2,TL,'sheet1','B10');
xlswrite(Filepath2,NDC,'sheet1','B11');
xlswrite(Filepath2,PC,'sheet1','B12');
xlswrite(Filepath2,MedianOSV_overall,'sheet1','B13'); 
xlswrite(Filepath2,MedianOSV_up,'sheet1','B14'); 
xlswrite(Filepath2,MedianOSV_down,'sheet1','B15');
xlswrite(Filepath2,MedianT_overall,'sheet1','B16');
xlswrite(Filepath2,MedianT_up,'sheet1','B17');
xlswrite(Filepath2,MedianT_down,'sheet1','B18');
xlswrite(Filepath2,MedianR_DC_overall,'sheet1','B19');
xlswrite(Filepath2,MedianR_DC_up,'sheet1','B20');
xlswrite(Filepath2,MedianR_DC_down,'sheet1','B21');
xlswrite(Filepath2,LenC,'sheet1','B22');
xlswrite(Filepath2,MeanLenC,'sheet1','B23');


% Snapshot

ST = TL - DCA(:,end);
SR_DC = abs(STM) / ST;

heading3 = {'Snapshot';'Tfinal'; 'Pfinal'; 'SPC'; 'SOSV'; 'STMV'; 'ST'; 'SR_DC'};


xlswrite(Filepath2,heading3,'sheet1','A26');

xlswrite(Filepath2,Tfinal,'sheet1','B27');
xlswrite(Filepath2,Pfinal,'sheet1','B28');
xlswrite(Filepath2,SPC,'sheet1','B29');
xlswrite(Filepath2,SOSV,'sheet1','B30');
xlswrite(Filepath2,STM,'sheet1','B31');
xlswrite(Filepath2,ST,'sheet1','B32');
xlswrite(Filepath2,SR_DC,'sheet1','B33');
